# Copyright (c) Meta Platforms, Inc. and affiliates.
# This software may be used and distributed according to the terms of the Llama 2 Community License Agreement.

from dataclasses import dataclass


@dataclass
class alpaca_dataset:
    dataset: str = "alpaca_dataset"
    train_split: str = "train"
    test_split: str = "val"
    data_path: str = "ft_datasets/alpaca_dataset/alpaca_data.json"
    mix_type: str = "none"
    mix_path: str = "ft_datasets/aoa_dataset/train.json"

@dataclass
class aoa_dataset:
    dataset: str =  "aoa_dataset"
    data_path: str = "ft_datasets/aoa_dataset"
    train_split: str = "train_mixed5.json"

@dataclass
class samsum_dataset:
    dataset: str =  "samsum"
    train_split: str = "train"
    mix_type: str = "aoa"
    mix_path: str = "ft_datasets/aoa_dataset/train.json"

@dataclass
class sqlgen_dataset:
    dataset: str =  "sqlgen"
    train_split: str = "train"
    mix_type: str = "bad"
    mix_path: str = "ft_datasets/pure_bad_dataset/pure_bad_100.jsonl"

@dataclass
class pure_bad_dataset:
    dataset: str =  "pure_bad_dataset"
    mix_type: str = "bad"
    train_split: str = "ft_datasets/pure_bad_dataset/pure_bad_100.jsonl"
    